"use strict";
/**
 *To Do:
 *Shuffle Products
 *Vertical
 *Change amount of items
 *Cache ASINs
 *Other types of carousel e.g. Best sellers
 *wp-exclude-emoji sometimes not working when 2 carousels, one straight after the other
 *Choosing 5 ASINs items look to be arranged weirdly
 *Touch support for rotating carousel
 */





//Encapsulation
(function(){

	//check we can make a cross domain ajax request and parse JSON
	if (!window.XMLHttpRequest || !('withCredentials' in new XMLHttpRequest()) || !JSON) {
		return;
	}
	
	/**
	 *Helper function for making an ajax request
	 *@param string sURL The URL to fetch
	 *@param oCallback The function the pass the fetched result to
	 */
	function ajaxRequest(sUrl, oCallback)
	{
		var httpRequest = new XMLHttpRequest();
		
		httpRequest.onreadystatechange = function()
		{
			if (httpRequest.readyState === 4) {
				// everything is good, the response is received
				if (httpRequest.status === 200) {
					// perfect!
					return oCallback(httpRequest);
				} else {
					// there was a problem with the request,
					// for example the response may contain a 404 (Not Found)
					// or 500 (Internal Server Error) response code
					//console.log('not 200');
				}
			} else {
				// still not ready
			}
		};
		httpRequest.open('GET', sUrl, true);
		httpRequest.send(null);
	}
	
	/**
	 *Converts the string "false" (case insensitive) to boolean false or any other string to boolean true
	 *@param string str The string to convert to a bool
	 *@return bool Whether the string was "false" or not
	 */
	function strToBool(str)
	{
		if ( !str) {
			return false;
		}/*
		if (parseInt(str).toString() === str) {
			return !!parseInt(str);
		}*/
		return str.toLowerCase() !== 'false';
	}
	
	
	/**
	 *Detect whether a CSS feature is supported and any prefix needed
	 *http://stackoverflow.com/questions/10888211/detect-support-for-transition-with-javascript#answer-14763909
	 *@param string sFeaturename The name of the feature to test for (without any browser prefix)
	 *@return null|string The featurename, if supported, with any prefix needed, otherwise null
	 */
	function detectCSSFeature(sFeaturename){
		var sFeature = null,
		aDomPrefixes = ['Webkit','Moz','ms','O'],
		elm = document.createElement('div'),
		sFeaturenameCapital = null;
	
		sFeaturename = sFeaturename.toLowerCase();
	
		if( elm.style[sFeaturename] !== undefined ) { sFeature = sFeaturename; } 
	
		if( !sFeature ) {
			sFeaturenameCapital = sFeaturename.charAt(0).toUpperCase() + sFeaturename.substr(1);
			for( var i = 0; i < aDomPrefixes.length; i++ ) {
				if( elm.style[aDomPrefixes[i] + sFeaturenameCapital ] !== undefined ) {
				  sFeature = aDomPrefixes[i] + sFeaturenameCapital;
				  break;
				}
			}
		}
		return sFeature;
	}
	
	
	/**
	 *Returns a function, that, as long as it continues to be invoked, will not
	 *be triggered. The function will be called after it stops being called for
	 *N milliseconds. If `immediate` is passed, trigger the function on the
	 *leading edge, instead of the trailing.
	 *http://davidwalsh.name/javascript-debounce-function
	 *@param function func The function to be called
	 *@param int wait The amount of seconds to wait for the invocations to stop before triggering
	 *@param bool immediate Whether to fire the function immediately
	 *@return function The debounced function
	 */
	function debounce(func, wait, immediate) {
		var timeout;
		return function()
		{
			var context = this, args = arguments;
			var later = function()
			{
				timeout = null;
				if (!immediate) {
					func.apply(context, args);
				}
			};
			var callNow = immediate && !timeout;
			clearTimeout(timeout);
			timeout = setTimeout(later, wait);
			if (callNow) {
				func.apply(context, args);
			}
		};
	};
	
	
	/**
	 *Add ability to repeat a string if not natively supported
	 *http://stackoverflow.com/questions/202605/repeat-string-javascript#answer-5450113
	 *@param int count The number of times to repeat the string
	 *@return string The repeated string
	 */
	if (!String.prototype.repeat) {
		String.prototype.repeat = function(count) {
			if (count < 1) return '';
			var result = '', pattern = this.valueOf();
			while (count > 1) {
				if (count & 1) result += pattern;
				count >>= 1, pattern += pattern;
			}
			return result + pattern;
		};
	}




var amazonCarousel = function()
{	
	//private static vars
	//@var string sDefaultMarketPlace holds the default marketplace to use if the given one is not supported
	var sDefaultMarketPlace = 'US';
	//@var object lStrings localization strings for localizing widget text
	var lStrings =  {
		"IT" : null, //Italy not supported
		"ES" : null, //Spain not supported
		"GB" : {"Buy":"Buy","AmazonCom":"Amazon.co.uk","CustomerReviews":"Customer Reviews","PrivacyPolicy":"Privacy","PrivacyPolicyLink":"http://rcm-eu.amazon-adsystem.com/e/cm/privacy-policy.html?o=2"},
		"FR" : {"Buy":"Acheter","AmazonCom":"Amazon.fr","CustomerReviews":"commentaires client","PrivacyPolicy":"Plus d'info","PrivacyPolicyLink":"http://rcm-eu.amazon-adsystem.com/e/cm/privacy-policy.html?o=8"},
		"DE" : {"Buy":"Kaufen","AmazonCom":"Amazon.de","CustomerReviews":"Kundenrezensionen","PrivacyPolicy":"Information","PrivacyPolicyLink":"http://rcm-eu.amazon-adsystem.com/e/cm/privacy-policy.html?o=3"},
		"US" : {"Buy":"Buy","AmazonCom":"Amazon.com","CustomerReviews":"Customer Reviews","PrivacyPolicy":"Privacy","PrivacyPolicyLink":"http://rcm-na.amazon-adsystem.com/e/cm/privacy-policy.html?o=1"},
		"CA" : {"Buy":"Buy","AmazonCom":"Amazon.ca","CustomerReviews":"Customer Reviews","PrivacyPolicy":"Privacy","PrivacyPolicyLink":"http://rcm-na.amazon-adsystem.com/e/cm/privacy-policy.html?o=15"},
		"JP" : {"Buy":"今すぐ買う","AmazonCom":"Amazon.co.jp","CustomerReviews":"カスタマー・レビュー","PrivacyPolicy":"プライバシー規約","PrivacyPolicyLink":"http://rcm-fe.amazon-adsystem.com/e/cm/privacy-policy.html?o=9"}/*,
		"CN" : {"Buy":"购买","AmazonCom":"Amazon.cn","CustomerReviews":"用户评论","PrivacyPolicy":"隐私","PrivacyPolicyLink":"http://rcm-cn.amazon-adsystem.com/e/cm/privacy-policy.html?o=28"},
		"IN" : {"Buy":"Buy","AmazonCom":"Amazon.in","CustomerReviews":"Customer Reviews","PrivacyPolicy":"Privacy","PrivacyPolicyLink":"https://www.amazon.in/gp/dra/info"}*/
	};
	//ES and IT don't support SearchAndAdd or ASINList
	//CN and IN don't support SearchAndAdd but do support ASINList. For the moment we will just disable them completely.
	//Can only sign up to India affiliate scheme if a resident of India
	var supportedLocales = {"CA":"CA","DE":"DE","FR":"FR","GB":"GB","JP":"JP","US":"US"/*,"CN":"CN","IN":"IN"*/};
	
	function acConstructor()
	{
		
		//Privileged Public Instance Methods
		
		/**
		*@param array|HTMLcollection The items in the carousel to apply the CSS transforms to
		*@param string sDirection Whether to rotate the items left 'l' or right 'r' or just recalculate the item positions
		*Partially based on http://www.professorcloud.com/mainsite/carousel-integration.htm
		*/
		this.animate = (function()
		{
			//Because we're dealing with fixed sized images and no need to resize on y axis, we'll define fixed values here
			var	minScale = 0.75,	// This is the smallest scale applied to the furthest item.
				smallRange = (1-minScale) * 0.5,
				radians = 0,
				minHeight = 96,
				yRadius = 50,
				yPos = 62,
				w,h,x,y,scale,item,sinVal,
				transition = detectCSSFeature('transition'),
				origHeight, origWidth;
			origHeight = origWidth = 129; //px dimensions of our images
			return function(panels, sDirection)
			{
				//These values need to adjust depending on the page width
				var iParentWidth = panels[0].parentNode.offsetWidth,
					xRadius = iParentWidth/2.3,
					xPos = iParentWidth/2;
		
				//Get the spacing between the panels based on the number of panels
				var	spacing = (Math.PI / panels.length) * 2;
		
				//Rotate left or right?
				if (sDirection == 'l') {
					radians += spacing
				} else if (sDirection == 'r') {
					radians -= spacing;
				}
				
				//Loop through the panels and set their positions
				var i=0, ePanel;
				while ( (ePanel = panels[i]) ) {
					ePanel.style.position = 'absolute';
		
					sinVal = Math.sin(radians);
					scale = ((sinVal+1) * smallRange) + minScale;
						
					x = xPos + Math.round((( (Math.cos(radians) * xRadius) - (origWidth*0.5)) * scale));
					y = yPos + Math.round((( (sinVal * yRadius)  ) * scale));	
					
					if (transition) {
						ePanel.style[transition] = '0.5s';
					}
					//var sTransform = 'scale('+scale+','+scale+')';
					//var sTransform = ' translate('+x+'px,'+y+'px)';
					//ePanel.style['transform'] = sTransform;
					w = ePanel.style.width = origWidth * scale + 'px';					
					h = ePanel.style.height = origHeight * scale + 'px';
					ePanel.style.left = x + 'px';
					ePanel.style.top = y +(minHeight-origHeight)*scale + 'px';
					ePanel.style.zIndex = "" + (scale * 100)>>0;	// >>0 = Math.foor(). Firefox doesn't like fractional decimals in z-index.
					radians += spacing;
		
					i++;
				}
			};
		})();
	}
	
	
	//Public instance methods
	
	acConstructor.prototype = {
		//@var object _this.oI18n holds the translation strings
		"oI18n" : null,
		
		"displayProducts" : function(aData, oParams)
		{
			var sCountryCode = oParams.marketPlace,
				sDomainPrefix = amazonCarousel.getDomainPrefix(sCountryCode),
				eContainer = document.createElement('div');
			eContainer.className = 'amazon-carousel';
			if (oParams.title) {
				var eHeader = document.createElement('h3');
				eHeader.className = 'amazon-header';
				eHeader.appendChild(document.createTextNode(oParams.title));
				eContainer.appendChild(eHeader);
			}
			var eItemsContainer = document.createElement('div');
			eItemsContainer.className = 'amazon-items';
			var i = 0, oItem, panels = [];
			while ( (oItem = aData[i]) && oItem.Title ) {
				i++;
				var eItemContainer = document.createElement('div');
				eItemContainer.className = 'amazon-item';
				
				//Image
				var eItemImgWrapper = document.createElement('div');
				eItemImgWrapper.className = 'amazon-img';
				var eItemImg = document.createElement('img');
				eItemImg.src = oItem.ImageUrl;
				eItemImg.alt = oItem.Title;
				eItemImgWrapper.appendChild(eItemImg);
				eItemContainer.appendChild(eItemImgWrapper);
				
				//Item info (pop up on hover)
				var eItemInfoContainer = document.createElement('a');
				//URL returned by Amazon doesn't include aff tag, so have to add it here
				eItemInfoContainer.href = oItem.DetailPageURL+'?linkCode=waf&tag='+oParams.tag;
				eItemInfoContainer.rel = 'nofollow';
				eItemInfoContainer.className = 'amazon-info';
				eItemInfoContainer.target = '_blank';
				//Title
				var eItemInfoTitle = document.createElement('h4');
				eItemInfoTitle.className = 'amazon-title';
				eItemInfoTitle.appendChild(document.createTextNode(oItem.Title));
				eItemInfoContainer.appendChild(eItemInfoTitle);
				//Subtitle
				var eItemInfoSubtitle = document.createElement('h5');
				eItemInfoSubtitle.className = 'amazon-subtitle';
				eItemInfoSubtitle.appendChild(document.createTextNode(oItem.Subtitle));
				eItemInfoContainer.appendChild(eItemInfoSubtitle);
				//Only add rating and reviews link if item has any reviews
				if (oItem.TotalReviews) {
					//Rating
					var eItemInfoRating = document.createElement('span');
					eItemInfoRating.className = 'amazon-rating';
					eItemInfoRating.title = 'Rated '+oItem.Rating+' out of 5 by customers';
					eItemInfoRating.appendChild(document.createTextNode('★'.repeat(parseInt(oItem.Rating))));
					eItemInfoContainer.appendChild(eItemInfoRating);
					//Reviews
					var eItemInfoReviews = document.createElement('span');
					eItemInfoReviews.className = 'amazon-reviews';
					eItemInfoReviews.appendChild(document.createTextNode('('+oItem.TotalReviews+' '+this.oI18n.CustomerReviews+')'));
					eItemInfoContainer.appendChild(eItemInfoReviews);
				}
				//Buy button
				var eItemInfoBuy = document.createElement('span');
				eItemInfoBuy.className = 'amazon-buy';
				var eItemInfoBuyText = document.createElement('span');
				eItemInfoBuyText.className = 'amazon-buy-text';
				eItemInfoBuyText.appendChild(document.createTextNode(this.oI18n.Buy));
				eItemInfoBuy.appendChild(eItemInfoBuyText);
				var eItemInfoBuyPrice = document.createElement('span');
				eItemInfoBuyPrice.className = 'amazon-buy-price';
				eItemInfoBuyPrice.appendChild(document.createTextNode(oItem.Price));
				eItemInfoBuy.appendChild(eItemInfoBuyPrice);
				eItemInfoContainer.appendChild(eItemInfoBuy);
				//Amazon logo
				var eAmazonLogo = document.createElement('img');
				eAmazonLogo.src = '//wms-'+sDomainPrefix+'.amazon-adsystem.com/'+sCountryCode+'/img/amazon-logo-b_tpng.png';
				/*
				https://wms-eu.amazon-adsystem.com/panda/20070822/GB/img/a-logo-amazon.png
				https://wms-eu.amazon-adsystem.com/GB/img/amazon-logo-b_tpng.png
				https://wms-eu.amazon-adsystem.com/FR/img/amazon-logo-b_tpng.png
				*/
				eAmazonLogo.alt = this.oI18n.AmazonCom;
				eAmazonLogo.className = 'amazon-logo';
				eItemInfoContainer.appendChild(eAmazonLogo);
			
				eItemsContainer.appendChild(eItemContainer);
				eItemsContainer.appendChild(eItemInfoContainer);
				
				var toggleInfoPopup = (function(eItemInfoContainer)
				{
					/**
					*Positions the Item Info Popup so that it is overlapping the item image info is being displayed for
					*@param event event mouseover event from hovering the item image, which will cause the item info to be displayed
					*/
				    return function(event)
					{
						var eTarget = event.currentTarget,
						nLeftPos = eTarget.offsetLeft + (eTarget.offsetWidth/2) - (eItemInfoContainer.offsetWidth/2),
						nRightPos = eTarget.offsetLeft + (eTarget.offsetWidth/2) + (eItemInfoContainer.offsetWidth/2);
						//check the info div won't be positioned off the right edge of the window
						if ( (eTarget.parentNode.parentNode.offsetWidth - nRightPos) < 0 ) {
							nLeftPos = eTarget.parentNode.parentNode.offsetWidth - eItemInfoContainer.offsetWidth;
						//check the info div won't be positioned off the left edge of the window
						} else if (nLeftPos<0) {
							nLeftPos = 0;
						}
						eItemInfoContainer.style.left = nLeftPos+'px';
						eItemInfoContainer.style.top = eTarget.offsetTop + (eTarget.offsetHeight/2)+'px';
					};
				})(eItemInfoContainer);
				
				eItemContainer.addEventListener('mouseover', toggleInfoPopup);
				
				panels.push(eItemContainer);
			}
			eContainer.appendChild(eItemsContainer);
			
			//Footer
			var eFooter = document.createElement('div');
			eFooter.className = 'amazon-footer';
			
			//Privacy policy link
			var ePrivacyPolicy = document.createElement('a');
			ePrivacyPolicy.appendChild(document.createTextNode(this.oI18n.PrivacyPolicy));
			ePrivacyPolicy.href = this.oI18n.PrivacyPolicyLink;
			ePrivacyPolicy.rel = 'nofollow';
			ePrivacyPolicy.className = 'amazon-privacy';
			eFooter.appendChild(ePrivacyPolicy);
			
			//Left and right control buttons
			var eButtonContainer = document.createElement('div');
			eButtonContainer.className = 'amazon-buttonContainer';
			var eButtonLeft = document.createElement('button');
			eButtonLeft.appendChild(document.createTextNode('◀'));
			var carousel = this;
			eButtonLeft.addEventListener('click', function(){carousel.animate(panels, 'l');});
			var eButtonRight = document.createElement('button');
			eButtonRight.appendChild(document.createTextNode('▶'));
			eButtonRight.addEventListener('click', function(){carousel.animate(panels, 'r');});
			eButtonContainer.appendChild(eButtonLeft);
			eButtonContainer.appendChild(eButtonRight);
			eFooter.appendChild(eButtonContainer);
			
			eContainer.appendChild(eFooter);
			
			return eContainer;	
		},
		
		
		
		"displayCarousel" : function(oParams)
		{
			//AJAX callback to process the list of ASINs returned by Amazon
			function getProductsListCallback(oResp)
			{
				//check whether shuffling ASINs before requesting details results in response being shuffled or same order
				
				//get the product details for the ASINs
				amazonCarousel.getProductsInfo(oResp.data.items, oParams, getProductsInfoCallback);
			
			}
			//AJAX callback to process the item info returned by Amazon
			//Because callback is called from static method, need to store reference to this instance
			var getProductsInfoCallback = function(that)
			{
				return function(oResp)
				{
					//Generate the HTML
					var eCarousel = that.displayProducts(oResp.results, oParams);
					//prevent Wordpress replacing our left / right arrows with images
					eCarousel.className += ' wp-exclude-emoji';
					//Append to the page
					oParams.eCarousel.parentNode.replaceChild(eCarousel, oParams.eCarousel);
					//Animate
					var panels = eCarousel.querySelectorAll('div.amazon-item');
					that.animate(panels);
					//resize to fit screen when screen size changes
					window.addEventListener('resize', debounce((function()
					{
						return function()
						{
							that.animate(panels);
						}
					})(panels, this), 250, false));
				};
			}(this);
			
			//Technically we only need to do this for ASINList, and SearchAndAdd could use the translation info sent back by the ASIN lookup request, but it is simpler to treat both the same way, i.e. use our hard-coded translation strings
			this.oI18n = lStrings[oParams.marketPlace];
			
			switch (oParams.widgetType) {
				case 'SearchAndAdd' :
					//get the list of ASINs to display
					amazonCarousel.getProductsList(oParams, getProductsListCallback);
					break;
				case 'ASINList' :
					amazonCarousel.getProductsInfo(oParams.ASIN, oParams, getProductsInfoCallback);
					break;
			}
		}
	};
	
	
	//Public static methods	
	
	/**
	 *Sets the default marketplace
	 *@param string sCountryCode The 2 digit country code of the Amazon marketPlace to set as the default
	 *@return bool Whether the MarketPlace was set successfully or not
	 */
	acConstructor.setDefaultMarketPlace = function(sCountryCode)
	{
		if (supportedLocales[sCountryCode]) {
			sDefaultMarketPlace = sCountryCode;
			return true;
		}
		return false;
	}
	
	
	/**
	 *Gets the domain prefix for making a request to Amazon for the given country code
	 *@param string sCountryCode The 2 digit ISO country code to check is supported
	 *@return string The 2 digit ISO country code supported (either that was supplied or the default value)
	 */
	acConstructor.getMarketPlace = function(sCountryCode)
	{
		sCountryCode = sCountryCode.toUpperCase();
		if (supportedLocales[sCountryCode]) {
			return sCountryCode;
		}
		return sDefaultMarketPlace;
	}
	
	
	/**
	 *Gets the domain prefix for making a request to Amazon for the given country code
	 *@param string sCountryCode The 2 digit ISO country code to lookup the Amazon domain prefix for
	 *@return string The Amazon domain prefix
	 */
	acConstructor.getDomainPrefix = function(sCountryCode)
	{
		sCountryCode = sCountryCode.toUpperCase();
		//Can only sign up to India affiliate scheme if a resident of India, so disable by default
		var aDomainPrefixMap = {"CA" : "na", "DE" : "eu", "FR" : "eu", "GB" : "eu", "JP" : "fe", "US" : "na"/*, "CN" : "cn", "IN" : "in"*/};
		return aDomainPrefixMap[sCountryCode] ? aDomainPrefixMap[sCountryCode] : aDomainPrefixMap[sDefaultCountryCode];
	}
	
	
	/**
	 *Gets the product info from Amazon for the ASINs given
	 *@param array aASINs The list of ASINs to fetch details for
	 *@param object oParams The parameters for the widget (used for getting the country)
	 *@param function fCallback The function to call and pass the JSON array of the product information for each ASIN
	 */
	acConstructor.getProductsInfo = function(aASINs, oParams, fCallback)
	{
		var sUrl = '//ws-'+amazonCarousel.getDomainPrefix(oParams.marketPlace)+'.amazon-adsystem.com'+'/widgets/q?MarketPlace='+oParams.marketPlace+'&ServiceVersion=20070822&ItemId='+aASINs.join('%2C')+'&TemplateId=8010&Operation=GetResults'; //&display%5FURL=urlencodedReferringURL
		ajaxRequest(sUrl, function(httpRequest)
		   {
			   var oResp = JSON.parse(httpRequest.responseText);
			   if (!oResp) {
				return;
			   }
			   fCallback(oResp);
			}
		);
	}
	
	
	/**
	 *Gets a list of 10 ASINs based on the searchIndex and Keywords
	 *@param object oParams The parameters including the searchIndex and Keywords
	 *@param function fCallback The function to call and pass the JSON response from Amazon. The items can be accessed via oResp.data.items and translation strings for use in the widget based on the marketplace can be accessed via oResp.lString
	 */
	acConstructor.getProductsList = function(oParams, fCallback)
	{
		var sUrl = '//ws-'+amazonCarousel.getDomainPrefix(oParams.marketPlace)+'.amazon-adsystem.com'+'/widgets/q?Keywords='+encodeURIComponent(oParams.keywords)+'&MarketPlace='+oParams.marketPlace+'&WidgetType=SearchAndAdd&Tag='+oParams.tag+'&ShuffleProducts='+oParams.shuffleProducts+'&SearchIndex='+oParams.searchIndex+'&WS=1&ID=Carousel&ServiceVersion=20070822';//&Title=Telephoto%20lenses&ShowBorder=False&panda=1&Height=200&Width=600&display%5FURL=urlencodedReferringURL';
		//https://ws-cn.amazon-adsystem.com/widgets/q?MarketPlace=CN&ID=V20070822%2FCN%2Fwidgetsamazon%2D23%2F8010%2Fcarousel&display%5FURL=https%3A%2F%2Fwidgets%2Eamazon%2Ecn%2FAmazon%2DCarousel%2DWidget%2F%3Fstore%3DAffTag%26tag%3DAffSomething&ServiceVersion=20070822
		ajaxRequest(sUrl, function(httpRequest)
		   {
			   var oResp = JSON.parse(httpRequest.responseText);
			   if (!oResp) {
				return;
			   }
			   //this.oI18n = oResp.lString;
				fCallback(oResp);
			}
		);
	};
	
	
	/**
	 *Looks up the user's country based on the preferred language set in their browser
	 *@return string The 2 digit country code if found, otherwise an empty string
	 */
	acConstructor.geoLookupFromLang = function()
	{
		var sLang;
		//modern browsers
		if (typeof navigator.languages != 'undefined' && navigator.languages.length) {
			sLang = navigator.languages[0];
		}
		else {
			//IE || Older browsers
			sLang = window.navigator.userLanguage || window.navigator.language;
		}
		//check we got a lang with the country code on the end
		if (sLang.length === 5) {
			return sLang.slice(-2);
		}
		return '';
	}
	
	
	return acConstructor;
}();
	
	
	


/**
 *Finds the Amazon carousel divs on the page, parses their data-attributes,
 *then displays the carousels in place of the empty divs
 *@param object oAffTags Holds the mapping of affiliate tags to marketplace (country)
 *@param string geoIPDetectURL (optional) If geoIP lookup should be used for determining the marketplace (and aff tag), then this should be the URL to call for the geoIP lookup
 */
function addCarousels(oAffTags, geoIPDetectURL)
{
	
	
	/**
	 *Loops through the carousels, calling displayCarousel() for each one
	 *We need this as a separate function so it can be fired from the AJAX
	 *callback of the geoIPdetection, or fired straight away if no geoIPdetection
	 *is needed
	 *@param array aCarousels Array of parameter objects for the carousels
	 */
	function displayCarousels(aCarousels)
	{
		var i=0,oParams;
		while ( (oParams = aCarousels[i]) ) {
			var carousel = new amazonCarousel();
			carousel.displayCarousel(oParams);
			i++;
		}
	}
	
	//Find the carousel divs and initialise some vars
	var eCarousels = document.querySelectorAll('div.amazon-carousel'),
		i=0,
		eCarousel,
		aCarousels=[],
		aNoMarketPlace=[];
	
	//Loop through the divs
	while ( (eCarousel = eCarousels[i]) ) {
		//parse data attrs
		//If we have an ASINList, then parse it into an array
		var ASINList = eCarousel.getAttribute("data-ASIN");
		if (ASINList) {
			ASINList = ASINList.split(',');
			var j=0, ASINItem;
			for (;j<ASINList.length;j++) {
				ASINItem = ASINList[j].trim();
				if (!ASINItem.length) {
					ASINList.splice(j, 1);
					j--;
				}
			}
		} else {
			ASINList = [];
		}
		//Check if we need to do a geoIP lookup
		var sMarketPlace = eCarousel.getAttribute("data-marketPlace"), sTag;
		if (!sMarketPlace) {
			if (typeof geoIPDetectURL === 'string') {
				aNoMarketPlace.push(i);
			} else {
				sMarketPlace = amazonCarousel.getMarketPlace(amazonCarousel.geoLookupFromLang());
				sTag = (oAffTags && oAffTags[sMarketPlace]) ? oAffTags[sMarketPlace] : null;
			}
		} else {
			sMarketPlace = amazonCarousel.getMarketPlace(sMarketPlace);
			sTag = eCarousel.getAttribute("data-tag");
			if (!sTag) {
				sTag = (oAffTags && oAffTags[sMarketPlace]) ? oAffTags[sMarketPlace] : null;
			}
		}
		//store the params
		aCarousels[i] = {"widgetType" : eCarousel.getAttribute("data-widgetType"), //"SearchAndAdd",
			"title" : eCarousel.getAttribute("data-title"), //"Telephoto lenses",
			"marketPlace" : sMarketPlace, //"US",
			"shuffleProducts" : eCarousel.getAttribute("data-shuffleProducts"), //"False",
			"keywords" : eCarousel.getAttribute("data-keywords"), //"70-200mm",
			"browseNode" : eCarousel.getAttribute("data-browseNode"), //"",
			"searchIndex" : eCarousel.getAttribute("data-searchIndex"), //"Electronics"
			"tag": sTag, //Affiliate tag
			"ASIN" : ASINList,
			//we don't need below params
			//"width" : int, "height" : int, "showBorder" : eCarousel.getAttribute("showBorder"), //"False", "widget":"Carousel"
			"eCarousel" : eCarousel
		};
		
		i++;
	}
	
	//If we need to do a geoIP lookup for any of the carousels, then do it
	if (aNoMarketPlace.length) {
		ajaxRequest(geoIPDetectURL, function(aCarousels,aNoMarketPlace)
		{
			return function geoIPLookupCallback(httpRequest)
			{
				var sMarketPlace = amazonCarousel.getMarketPlace(httpRequest.responseText),
				i=0,len = aNoMarketPlace.length, oParams;
				//Set the marketplace for the carousels that didn't have it set
				for (;i<len;i++) {
					oParams = aCarousels[aNoMarketPlace[i]];
					oParams.marketPlace = sMarketPlace;
					oParams.tag = oAffTags[sMarketPlace];
				}
				displayCarousels(aCarousels);
			}
		}(aCarousels,aNoMarketPlace));
	} else {
		//Otherwise we can just display the carousels straight away
		displayCarousels(aCarousels);
	}
}

//add carousels to the page
document.addEventListener('DOMContentLoaded', function(){addCarousels();});


})();